;; -*- Mode: Scheme -*-

;; asyn_http_bench in scheme

(define (string-concat . strings)
  (letrec ((cat (lambda (strings)
		  (cond ((null? strings) "")
			((null? (cdr strings)) (car strings))
			(else (string-append
			       (car strings)
			       (cat (cdr strings))))))))
    (cat strings)))

;; grab <url> from <addr> using <n> parallel connections,
;; each iterating <i> times.

(define (url-test addr url n i)
  (let ((wheel (make-wheel 64 30.0)))
    (define (get-url addr url i ident)
      (let outer-loop ((x i))
	(if (> x 0)
	    (let ((socket (make-chained-socket wheel AF_INET SOCK_STREAM 0))
		  (request (string-concat "GET /" url " HTTP/1.0\r\n\r\n")))
	      ;(display-things "chain" (number->string ident) "iter" (number->string x))
	      (connect socket addr)
	      (send socket request)
	      (let inner-loop ((data (recv socket 1024)))
		(if (string=? data "")
		    #f
		    (inner-loop (recv socket 1024))))
	      (close socket)
	      (outer-loop (- x 1))))))

    (let loop ((j n))
      (if (> j 0)
	  (begin
	    (spawn wheel (lambda () (get-url addr url i j)))
	    (loop (- j 1)))))
    (spin wheel)
    ))

;(let ((args (argv)))
;  (let ((addr (list-ref args 1))
;	(url  (list-ref args 2))
;	(n    (string->number (list-ref args 3)))
;	(i    (string->number (list-ref args 4)))
;	(start (runtime)))
;    (url-test addr url n i)
;    (newline)))
